package com.bonait.bnframework.common.constant;

import android.app.Application;
import android.content.Context;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.db.mode.BPA_PLCADDRESS;
import com.bonait.bnframework.common.db.mode.BPA_USER;
import com.bonait.bnframework.common.db.mode.Res_PLCADDRESS;
import com.bonait.bnframework.common.db.res.StatusMode;
import com.bonait.bnframework.common.model.AddrType;
import com.bonait.bnframework.common.model.mode.CloudGood;
import com.bonait.bnframework.common.model.mode.DeviceInformation;
import com.bonait.bnframework.common.model.mode.OrganizeMode;
import com.bonait.bnframework.common.model.mode.ProcessT;
import com.bonait.bnframework.common.model.mode.ResALLData;
import com.bonait.bnframework.common.model.mode.VersionSelectionEnum;
import com.bonait.bnframework.common.utils.ScreenUtils;
import com.bonait.bnframework.modules.home.adapter.FragmentAdapter;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * 配置文件
 */
public class ConfigName {
    //region 单例模式
    private static ConfigName mInstance; //实例变量设置私有，防止直接通过类名访问

    private ConfigName() { //默认构造函数私有，防止类外直接new创建对象
    }

    public static synchronized ConfigName getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance == null) {
            mInstance = new ConfigName();
        }
        return mInstance;
    }
    //endregion

    //region 程序进入界面
    public Context dishesCon;
    public Context Home;
    public Application app;
    public boolean IsPortraitScreen = true;//是否竖屏
    //endregion

    //region 主页
    /**
     * 主页流
     */
    public FragmentAdapter fragmentAdapter = null;
    //endregion

    //region SD卡路径设置
    /**
     * SD卡路径
     */
    public String sdCardPath;
    /**
     * 应用程序 Res 根路径
     */
    public String appResRoot;
    /**
     * Db文件路径
     */
    public static String dbPath = "";
    //endregion

    //region 店铺配置
    /**
     * 店铺名称
     */
    public String Shop_Name = "黑菠萝奶茶机";
    /**
     * 门店Id
     */
    public String ClientAutoKey = "79";
    /**
     * 店铺设备号
     */
    public String DeviceAutoKey = "159";
    /**
     * 设备id
     */
    public String DeviceId = "未知";
    //endregion

    //region MQTT配置中心
    /**
     * 用户名
     */
    public String mqtt_userName = "emqx_u_block";
    /**
     * 密码
     */
    public String mqtt_passWord = "emqx_p_admin8765490789";
    /**
     * ip地址
     */
    public String mqtt_ip = "10.2.1.21";
    /**
     * post端口
     */
    public int mqtt_post = 1883;
    /**
     * 订阅主题
     */
    public String mqtt_topic = "DOWN/MORKT/BUSINESS/";
    public String mqtt_hearttopic = "UP/MORKT/HEARTBEAT";
    //endregion

    //region 环境配置
    /**
     * 环境配置
     */
    public String Environment = "开发环境";
    //endregion

    //region 登录信息
    /**
     * 用户信息
     */
    public BPA_USER user = new BPA_USER();
    //endregion

    //region 组织信息
    /**
     * 组织信息
     */
    public OrganizeMode organizeMode = null;
    /**
     * 设备信息
     */
    public DeviceInformation deviceInformation = null;
    //endregion

    //region 版本信息
    /**
     * 版本更新，当前版本
     */
    public String Version = "1.0";
    //endregion

    //region 是否手动下单
    /**
     * 是否手动下单
     */
    public Boolean IsUserDownOrder = false;
    //endregion

    //region 系统设置表
    /**
     * 订单上报周期，默认一小时 *60
     */
    public int OrderPushTime = 3600;
    /**
     * 料仓余量上报周期，默认10分钟 *60
     */
    public int SilosValuePushTime = 600;
    /**
     * 其他传感器上报周期，默认10分钟 *60
     */
    public int OtherValuePushTime = 600;
    /**
     * 管道排空周期，默认一小时 *60
     */
    public int PipeDrainCycleTime = 3600;
    /**
     * 订单未制作超时规则，默认20分钟 *60
     */
    public int OrderTimeout = 1200;
    /**
     * 料仓补料阈值，500g
     */
    public int SiloFeedThreshold = 500;
    /**
     * 料仓告警阈值，50g
     */
    public int SiloAlarmThreshold = 50;
    /**
     * 自动清洗时间，默认一小时 *60
     */
    public int AICleanTime = 3600;
    //endregion

    //region PlC连接参数
    /**
     * Plc是否连接
     */
    public boolean PlcIsConnect = false;
    /**
     * Plc地址
     */
    public String Address = "192.168.1.100";
    /**
     * Plc端口
     */
    public int Post = 502;
    //endregion

    //region URL
    //Sass地址
    public String SaasAddress = "http://order.test1.com";
    //public String SaasAddress="https://bpa.black-pa.com:21527";
    //public String SaasAddress="https://witt.black-pa.com";

    //获取店铺详细信息 Get
    public String GetStore = "kitchen/api/StoreHelper/GetStoreInfoById?storeId=";
    //获取设备信息分页 Get
    public String GetDeviceInformation = "kitchen/api/CommInteface/GetDeviceInfo?storeId=%s&autoKey=%s";
    //获取 获取基础信息（所有物料信息、设备工序模型、菜谱列表、商品小类、商品大类、单位数据
    public String GetBaseDataModel = "kitchen/api/CommInteface/GetBaseDataModel?storeId=%s&autoKey=%s";
    //获取 商品
    public String GetGoods = "kitchen/api/CommInteface/GetDeviceGood?storeId=%s&deviceId=%s";
    //获取商品配方信息
    public String GetGoodsBom = "kitchen/api/CommInteface/GetDeviceGoodBomTechnology?goodsId=%s&deviceId=%s";
    //上传商品
    public String UpdateGoods = "kitchen/api/CommInteface/SendGoodsInfo";
    //获取商品信息
    public String GetGoodIsCloud = "kitchen/api/CommInteface/GetGoodsInfo?goodsName=%s";

    //版本更新
    public String UpdateVersion = "http://111.9.47.105:18097/api/Version/GetLatest";
    //endregion

    //region PLC地址配置
    /**
     * PLC地址
     */
    public static ConcurrentHashMap<String, BPA_PLCADDRESS> PLC_Address = new ConcurrentHashMap<String, BPA_PLCADDRESS>();
    /**
     * 大炒基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_燃气大炒 = new ArrayList<Res_PLCADDRESS>() {{

        //PLC输入
        add(new Res_PLCADDRESS("监控信号一", "-------------", 0, 0));
        add(new Res_PLCADDRESS("监控_急停按钮", "V20.0", 1, 0));
        add(new Res_PLCADDRESS("监控_搅拌上限", "V20.1", 1, 0));
        add(new Res_PLCADDRESS("监控_搅拌下限", "V20.2", 1, 0));
        add(new Res_PLCADDRESS("监控_锅后限位", "V20.3", 1, 0));
        add(new Res_PLCADDRESS("监控_搅拌原点", "V20.4", 1, 0));
        add(new Res_PLCADDRESS("监控_油泵故障", "V20.5", 1, 0));
        add(new Res_PLCADDRESS("监控_变频器故障", "V20.6", 1, 0));
        add(new Res_PLCADDRESS("监控_点火正常", "V20.7", 1, 0));
        add(new Res_PLCADDRESS("监控_点火异常", "V21.0", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入1", "V21.1", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入2", "V21.2", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入3", "V21.3", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入4", "V21.4", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入5", "V21.5", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入6", "V21.6", 1, 0));
        add(new Res_PLCADDRESS("监控_备用输入7", "V21.7", 1, 0));

        //监控信号二
        add(new Res_PLCADDRESS("监控信号二", "-------------", 0, 0));
        add(new Res_PLCADDRESS("监控-油泵", "V50.0", 1, 0));
        add(new Res_PLCADDRESS("监控-搅拌", "V50.1", 1, 0));
        add(new Res_PLCADDRESS("监控-强火", "V50.2", 1, 0));
        add(new Res_PLCADDRESS("监控-小火", "V50.3", 1, 0));
        add(new Res_PLCADDRESS("监控-中火", "V50.4", 1, 0));
        add(new Res_PLCADDRESS("监控-大火", "V50.5", 1, 0));
        add(new Res_PLCADDRESS("监控-点火复位", "V50.6", 1, 0));
        add(new Res_PLCADDRESS("监控-点火自动", "V50.7", 1, 0));
        add(new Res_PLCADDRESS("监控-点火手动", "V51.0", 1, 0));
        add(new Res_PLCADDRESS("监控-报警", "V51.1", 1, 0));
        add(new Res_PLCADDRESS("监控-搅拌上升", "V51.2", 1, 0));
        add(new Res_PLCADDRESS("监控-搅拌下降", "V51.3", 1, 0));
        add(new Res_PLCADDRESS("监控-锅前", "V51.4", 1, 0));
        add(new Res_PLCADDRESS("监控-锅后", "V51.5", 1, 0));
        add(new Res_PLCADDRESS("监控-备用泵", "V51.6", 1, 0));
        add(new Res_PLCADDRESS("监控-备用气缸", "V51.7", 1, 0));

        //故障类
        add(new Res_PLCADDRESS("故障信号", "-------------", 0, 0));
        add(new Res_PLCADDRESS("急停按下！", "V101.0", 1, 0));
        add(new Res_PLCADDRESS("油泵故障！", "V101.1", 1, 0));
        add(new Res_PLCADDRESS("搅拌故障！", "V101.2", 1, 0));
        add(new Res_PLCADDRESS("点火异常！", "V101.3", 1, 0));
        add(new Res_PLCADDRESS("高温报警！", "V101.4", 1, 0));
        add(new Res_PLCADDRESS("备用故障1", "V101.5", 1, 0));
        add(new Res_PLCADDRESS("备用故障2", "V101.5", 1, 0));
        add(new Res_PLCADDRESS("备用故障3", "V101.5", 1, 0));

        //控制模型
        add(new Res_PLCADDRESS("主运行画面", "-------------", 0, 0));
        add(new Res_PLCADDRESS("系统启停开关", "V220.0", 0, 1));
        add(new Res_PLCADDRESS("超温停气开关", "V220.1", 0, 1));
        add(new Res_PLCADDRESS("点火启动开关", "V220.2", 0, 1));
        add(new Res_PLCADDRESS("点火复位开关", "V220.3", 0, 1));
        add(new Res_PLCADDRESS("点火手自动切换开关", "V220.4", 0, 1));
        add(new Res_PLCADDRESS("小火开关（一圈）", "V220.5", 0, 1));
        add(new Res_PLCADDRESS("中火开关（二圈）", "V220.6", 0, 1));
        add(new Res_PLCADDRESS("大火开关（三圈）", "V220.7", 0, 1));
        add(new Res_PLCADDRESS("强火开关（四圈）", "V221.0", 0, 1));
        add(new Res_PLCADDRESS("小火比例阀开度", "VD1500", 0, 1));
        add(new Res_PLCADDRESS("中火比例阀开度", "VD1504", 0, 1));
        add(new Res_PLCADDRESS("大火比例阀开度", "VD1508", 0, 1));
        add(new Res_PLCADDRESS("强火比例阀开度", "VD1512", 0, 1));
        add(new Res_PLCADDRESS("搅拌点动开关", "V221.1", 0, 1));
        add(new Res_PLCADDRESS("搅拌启动开关", "V221.2", 0, 1));
        add(new Res_PLCADDRESS("搅拌停止开关", "V221.3", 0, 1));
        add(new Res_PLCADDRESS("搅拌速度", "VD1200", 0, 1));
        add(new Res_PLCADDRESS("炒锅当前温度", "VD2250", 1, 1));
        add(new Res_PLCADDRESS("炒锅温度修正", "VD1204", 0, 1));
        add(new Res_PLCADDRESS("炒锅温度上限设置", "VD1828", 0, 1));


        //升降画面
        add(new Res_PLCADDRESS("升降画面", "-------------", 0, 0));
        add(new Res_PLCADDRESS("搅拌上升", "V221.4", 1, 1));
        add(new Res_PLCADDRESS("搅拌下降", "V221.5", 1, 1));
        add(new Res_PLCADDRESS("锅口向前", "V221.6", 1, 1));
        add(new Res_PLCADDRESS("锅口向后", "V221.7", 1, 1));

        //称重画面
        add(new Res_PLCADDRESS("称重画面", "-------------", 0, 0));
        add(new Res_PLCADDRESS("料仓1出料", "V222.0", 1, 1));
        add(new Res_PLCADDRESS("料仓2出料", "V222.1", 1, 1));
        add(new Res_PLCADDRESS("炒锅当前重量", "VD500", 1, 0));
        add(new Res_PLCADDRESS("设定重量", "VD510", 0, 1));
        add(new Res_PLCADDRESS("设定提前量", "VD514", 0, 1));

        //称重画面
        add(new Res_PLCADDRESS("心跳", "-------------", 0, 0));
        add(new Res_PLCADDRESS("上位机-PLC", "V280.0", 1, 1));
        add(new Res_PLCADDRESS("PLC-上位机", "V280.1", 1, 1));
    }};
    /**
     * 大炒工序模型
     */
    public List<ProcessT> Process_燃气大炒 = new ArrayList<ProcessT>() {{
        add(new ProcessT("物料", Arrays.asList()));
        add(new ProcessT("主料", Arrays.asList("主料名称")));
        add(new ProcessT("搅拌", Arrays.asList("搅拌速度","搅拌状态")));
        add(new ProcessT("火力设置", Arrays.asList("一环功率", "二环功率", "三环功率", "四环功率")));
        add(new ProcessT("约束条件", Arrays.asList("温度设定", "锅内重量", "等待(秒)")));
    }};

    /**
     * 根据名称获取变量
     *
     * @param item
     * @return
     */
    public String GetProcessTypeVal(String item) {
        String data = "";
        if (item.equals("搅拌状态")) {
            data = "启动、停止";
        } else if (item.equals("位置动作")) {
            data = "炒菜位、倒菜位、清洗位";
        }
        return data;
    }

    /**
     * 速度
     */
    public ConcurrentHashMap<String, Integer> StirringSpeed = new ConcurrentHashMap<String, Integer>() {{
        put("停止", 0);
        put("最低", 10);
        put("低速", 20);
        put("中速", 30);
        put("高速", 40);
        put("最高", 50);
        put("极高", 60);
    }};
    /**
     * 挡位 功率
     */
    public ConcurrentHashMap<String, Integer> HeatingGear = new ConcurrentHashMap<String, Integer>() {{
        put("停止", 0);
        put("一档", 1);
        put("二档", 2);
        put("三档", 3);
        put("四档", 4);
        put("五档", 5);
        put("六档", 6);
        put("七档", 7);
        put("八档", 8);
    }};
    //region 火力最大级别
    /**
     * 最大火力级别
     */
    public String HuoLi = "八档";
    /**
     * 最大温度：默认温度
     */
    public int MaxTemp = 200;
    /**
     * 是否打开火力
     */
    public boolean IsOpenHuoLi = false;
    //endregion

    /**
     * Bottom 按钮
     */
    public List<String> BottomList = new ArrayList<String>() {{
        add("搅拌点动开关");
        add("搅拌启动开关");
        add("搅拌停止开关");

        add("搅拌上升");
        add("搅拌下降");
        add("锅口向前");
        add("锅口向后");
    }};

    //endregion

    //region 云端数据
    /**
     * 云端数据
     */
    public ResALLData cloudData = null;
    /**
     * 云端商品
     */
    public List<CloudGood> cloudGoods = new ArrayList<>();
    //endregion

    //region 选配版本信息
    /**
     * 版本信息
     */
    public String[] versionSelectionValues = new String[]{"燃气自翻炒锅"};
    /**
     * 选配版本信息
     */
    public String versionSelectionEnum = "燃气自翻炒锅";
    //endregion

    //region 用户角色
    public List<String> UserRole = new ArrayList<String>() {{
        add("一般用户");
        add("研发用户");
        add("超级管理员");
    }};
    //endregion

    //region 计数累计
    /**
     * 锅口朝向次数
     */
    public int gkcxCount=0;
    /**
     * 搅拌分钟数
     */
    public int jiaobanCount = 0;//搅拌分钟数
    /**
     * 清洗次数
     */
    public int qingxiCount = 0;
    /**
     * 投料次数
     */
    public int touliaoCount = 0;
    /**
     * 液体料次数
     */
    public int yetiliaoCount = 0;

    /**
     * 延迟加热次数
     */
    public int yanchiCount = 0;
    /**
     * 加热次数
     */
    public int jiareCount = 0;
    /**
     * 加热稳定性次数
     */
    public int jiarewendingCount = 0;
    /**
     * 炒菜运行
     */
    public int RunCount = 0;
    //endregion
}
