package com.bonait.bnframework.modules.home.fragment;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.RecyclerView;
import androidx.recyclerview.widget.StaggeredGridLayoutManager;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPE;
import com.bonait.bnframework.common.db.res.StatusMode;
import com.bonait.bnframework.common.db.res.lcMode;
import com.bonait.bnframework.common.helper.CountDownTimerExt;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.image.MyBitmapUtils;
import com.bonait.bnframework.common.message.MessageLooper;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.adapter.devicestatus_adapter;
import com.bonait.bnframework.modules.home.adapter.liaochang_adapter;
import com.bonait.bnframework.modules.home.fragment.from.CpxzActivity;
import com.capton.colorfulprogressbar.ColorfulProgressbar;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;
import com.qmuiteam.qmui.widget.textview.QMUILinkTextView;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class MakeGoodFragment extends BaseFragment {
    //region 变量
    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;//顶部标题

    @BindView(R.id.recycler_view_sbzt)
    RecyclerView recycler_view_sbzt;

    @BindView(R.id.recycler_view_gzzt)
    RecyclerView recycler_view_gzzt;


    @BindView(R.id.cpfm)
    ImageView cpfm;//菜谱封面
    @BindView(R.id.caipumingcheng)
    TextView caipumingcheng;//菜谱名称
    @BindView(R.id.shengyushijian)
    TextView shengyushijian;//剩余时间
    @BindView(R.id.jingdu)
    ColorfulProgressbar jingdu;//进度条
    @BindView(R.id.startbutton)
    Button startbutton;
    @BindView(R.id.xzcp)
    Button xzcp;

    @BindView(R.id.dialog_xtkz)
    RelativeLayout dialog_xtkz;

    @BindView(R.id.dialog_hlkz)
    RelativeLayout dialog_hlkz;

    @BindView(R.id.dialog_kbkz)
    RelativeLayout dialog_kbkz;

    @BindView(R.id.dialog_jykz)
    RelativeLayout dialog_jykz;


    /**
     * 当前制作商品信息
     */
    BPA_GOODS good = null;
    private Context context;
    //endregion

    //region 界面
    public MakeGoodFragment() {
    }

    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_make_good, null);
        ButterKnife.bind(this, root);
        return root;
    }

    public Activity activity;

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        activity = getActivity();
        context = getContext();
        initTopBar();
        Initdata();
        StatusThread();
    }

    /**
     * 初始化TopBar
     */
    private void initTopBar() {
        mTopBar.setTitle("菠萝燃气炒菜系统" + ConfigName.getInstance().Version);
    }
    //endregion

    //region 私有函数

    /**
     * 点击事件
     *
     * @param view
     */
    @OnClick({R.id.xzcp, R.id.startbutton
            , R.id.btn_xtkz, R.id.btn_hlkz
            , R.id.btn_sjkz, R.id.btn_jykz
            , R.id.close_xtkz, R.id.close_hlkz
            , R.id.close_kbkz, R.id.close_jykz})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.xzcp://选择菜谱按钮点击
                skipToActivity(CpxzActivity.class);
                ToastUtils.info("打开菜谱选择界面");
                break;
            case R.id.btn_xtkz:
                SetVisibility(1);
                break;
            case R.id.btn_hlkz:
                SetVisibility(2);
                break;
            case R.id.btn_sjkz:
                SetVisibility(3);
                break;
            case R.id.btn_jykz:
                SetVisibility(4);
                break;
            case R.id.close_xtkz:
            case R.id.close_hlkz:
            case R.id.close_kbkz:
            case R.id.close_jykz:
                SetVisibility(0);
                break;
            case R.id.startbutton:
                if (ExecuteTheRecipe.IsStart) {
                    //按钮点击
                    String title = "停止操作提示！";
                    String message = "请问客官确定要停止制作吗,小菠萝会生气的,啊啊啊啊啊啊啊...我的饭饭？";
                    AlertDialogUtils.showDialog(context, title, message, new QMUIDialogAction.ActionListener() {
                        @Override
                        public void onClick(QMUIDialog dialog, int index) {
                            //强制结束
                            ExecuteTheRecipe.SetForcedEnd();
                            dialog.dismiss();
                        }
                    });
                } else {
                    if (good == null) {
                        ToastUtils.info("请先选择一个商品");
                        return;
                    }

//                    if (!IsMake(false)) {
//                        return;
//                    }

                    //按钮点击
                    String title = "开始操作提示！";
                    String message = "请问客官确定要开始制作吗,小菠萝好开心呀,马上就有好吃的耶？";
                    AlertDialogUtils.showDialog(context, title, message, new QMUIDialogAction.ActionListener() {
                        @Override
                        public void onClick(QMUIDialog dialog, int index) {
                            ExecuteTheRecipe.StopForcedEnd();
                            onRecordStart();
                            dialog.dismiss();
                        }
                    });
                }
                break;
        }
    }
    //endregion

    //region 公共函数

    /**
     * 初始化数据
     */
    public void Initdata() {
        //1.初始化状态数据
        InitStatusdata();
        //2.
        SetProcesssUI(0);
        startbutton.setText("开始烹饪");
        startbutton.setBackgroundResource(R.drawable.bg_btn_login_selected);
        SetVisibility(0);
        //3.接收选择菜谱事件
        DataBus.getInstance().mListener = new MyClickListener() {
            @Override
            public void clickListener(View v, Object data) {

                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
//                        if (!IsMake(true)) {
//                            return;
//                        }
                        good = (BPA_GOODS) data;
                        SetProcesssUI(0);
                    }
                });
            }

            @Override
            public void clickListenerNew(View v, int k, Object data) {

            }
        };
    }

    /**
     * 状态线程
     */
    public void StatusThread() {
        //商品制作线程
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {

                        if (ExecuteTheRecipe.IsStart && good != null) {
                            long startTime = System.currentTimeMillis(); //起始时间
                            ExecuteTheRecipe.showlog("--------------------------------------");
                            ExecuteTheRecipe.showlog("开始烹饪菜谱【" + good.name + "】");

                            try {
                                //获取工艺
                                ArrayList<BPA_GOODSRECIPE> goodsrecipes = QueryDB.GetGoodsSrecipeID(good.id);
                                for (BPA_GOODSRECIPE item : goodsrecipes) {
                                    ExecuteTheRecipe.Execute(item);
                                }
                            } catch (Exception ex) {
                                ToastUtils.error("异常信息:" + ex.getMessage());
                            } finally {
                                long endTime = System.currentTimeMillis(); //结束时间
                                int time = (int) ((endTime - startTime) / 1000);

                                ExecuteTheRecipe.showlog("结束烹饪菜谱【" + good.name + "】,关闭搅拌、关闭加热," + String.format("方法使用时间 %d s", time));

                                if (!ExecuteTheRecipe.IsForcedEnd) {
                                    QueryDB.UpdateGoodsMakeTime(good.id, time);
                                }

                                Activity activity = getActivity();
                                if (activity != null) {
                                    activity.runOnUiThread(new Runnable() {
                                        @Override
                                        public void run() {
                                            onRecordStop();
                                            if (ExecuteTheRecipe.IsForcedEnd)//强制结束
                                            {
                                                ExecuteTheRecipe.showlog("菜谱【" + good.name + "】已强制结束...");
                                                ExecuteTheRecipe.StopForcedEnd();//设置恢复强制结束
                                            }
                                        }
                                    });
                                }
                                ExecuteTheRecipe.showlog("--------------------------------------");
                            }
                        }
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {

                    }
                }
            }
        }).start();


        //刷新UI监控
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        if (ConfigName.getInstance().PlcIsConnect) {
                            for (StatusMode mode : sbzt) {
                                Object obj = ExecuteTheRecipe.ReadPLC(mode.YName);
                                if (obj != null) {
                                    mode.Status = (boolean) obj;
                                }
                            }

                            for (StatusMode mode : gzzt) {
                                Object obj = ExecuteTheRecipe.ReadPLC(mode.YName);
                                if (obj != null) {
                                    mode.Status = (boolean) obj;
                                }
                            }

                            getActivity().runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    ReshData();
                                }
                            });
                        }

                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        ToastUtils.info("异常信息:" + e.getMessage());
                    }
                }
            }
        }).start();
    }

    //endregion

    //region 设备监控状态
    /**
     * 设备状态
     */
    public List<StatusMode> sbzt = new ArrayList<>();
    public devicestatus_adapter adapter_sbzt = null;
    /**
     * 故障状态
     */
    public List<StatusMode> gzzt = new ArrayList<>();
    public devicestatus_adapter adapter_gzzt = null;

    /**
     * 初始化数据
     */
    public void InitStatusdata() {
        sbzt.clear();
        sbzt.add(new StatusMode("急停按钮", "监控_急停按钮", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        sbzt.add(new StatusMode("搅拌上限", "监控_搅拌上限", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        sbzt.add(new StatusMode("搅拌下限", "监控_搅拌下限", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        sbzt.add(new StatusMode("锅后限位", "监控_锅后限位", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        sbzt.add(new StatusMode("搅拌原点", "监控_搅拌原点", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        sbzt.add(new StatusMode("点火正常", "监控_点火正常", false, R.mipmap.status_y, R.mipmap.status_z, 0));


        gzzt.clear();
        gzzt.add(new StatusMode("急停按下", "急停按下！", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        gzzt.add(new StatusMode("油泵故障", "油泵故障！", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        gzzt.add(new StatusMode("搅拌故障", "搅拌故障！", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        gzzt.add(new StatusMode("点火异常", "点火异常！", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        gzzt.add(new StatusMode("高温报警", "高温报警！", false, R.mipmap.status_y, R.mipmap.status_z, 0));
        gzzt.add(new StatusMode("备用故障1", "备用故障1", false, R.mipmap.status_y, R.mipmap.status_z, 0));

        StaggeredGridLayoutManager layout = new StaggeredGridLayoutManager
                (3, StaggeredGridLayoutManager.VERTICAL);
        recycler_view_sbzt.setLayoutManager(layout);
        adapter_sbzt = new devicestatus_adapter(getContext(), sbzt);
        recycler_view_sbzt.setAdapter(adapter_sbzt);


        StaggeredGridLayoutManager layout1 = new StaggeredGridLayoutManager
                (3, StaggeredGridLayoutManager.VERTICAL);
        recycler_view_gzzt.setLayoutManager(layout1);
        adapter_gzzt = new devicestatus_adapter(getContext(), gzzt);
        recycler_view_gzzt.setAdapter(adapter_gzzt);
    }

    /**
     * 刷新数据
     */
    public void ReshData() {
        adapter_sbzt.refresh();
        adapter_gzzt.refresh();
    }
    //endregion

    //region 计时器
    private CountDownTimerExt countDownTimer = null;//计时器

    /**
     * 启动
     */
    public void onRecordStart() {
        if (good != null) {
            startbutton.setText("强制结束");
            startbutton.setBackgroundResource(R.drawable.bg_btn_login_red);
            xzcp.setVisibility(View.INVISIBLE);

            int time = good.maketime;
            SetProcesssUI(0);
            if (countDownTimer == null) {
                countDownTimer = new CountDownTimerExt(time * 1000, 1000) {
                    @Override
                    public void onTimerTick(long value) {
                        int overtime = (int) ((value) / 1000);//剩余时间
                        SetProcesssUI(time - overtime);
                    }

                    @Override
                    public void onTimerFinish() {
                        SetProcesssUI(time);
                    }
                };
            }
            countDownTimer.start();
            ExecuteTheRecipe.IsStart = true;
        }
    }

    /**
     * 停止
     */
    public void onRecordStop() {
        if (good != null) {
            startbutton.setText("开始烹饪");
            startbutton.setBackgroundResource(R.drawable.bg_btn_login_selected);
            xzcp.setVisibility(View.VISIBLE);

            SetProcesssUI(0);

            if (countDownTimer != null) {
                countDownTimer.stop();
                countDownTimer = null;
            }

            ExecuteTheRecipe.IsStart = false;
        }
    }
    //endregion

    //region 私有

    /**
     * 是否可以制作商品
     *
     * @return
     */
    public boolean IsMake(boolean k) {
        if (!ConfigName.getInstance().PlcIsConnect) {
            ToastUtils.warning("PLC未准备就绪!!!");
            return false;
        }

        Object chushiover = ExecuteTheRecipe.getListingValue("监控_急停按钮");
        if (chushiover == null || (boolean) chushiover) {
            ToastUtils.warning("设备停止,请先启动设备!!!");
            return false;
        }

        if (ExecuteTheRecipe.IsStart && k) {
            ToastUtils.warning("客官,商品制作未结束请勿进行其他操作.请耐心等待商品制作结束!!!");
            return false;
        }

        return true;
    }

    /**
     * 设置进度条百分比
     *
     * @param usertime
     */
    public void SetProcesssUI(int usertime) {
        try {
            if (good == null) {
                caipumingcheng.setText("暂无");
                jingdu.setProgress(0);
                jingdu.setSecondProgress(0);
                shengyushijian.setText("未知");
                new MyBitmapUtils().disPlay(cpfm, "未知");
            } else {
                caipumingcheng.setText(good.name + "");
                jingdu.setProgress((usertime * 100) / good.maketime);
                jingdu.setSecondProgress((usertime * 100) / good.maketime);
                shengyushijian.setText(formatTime(good.maketime - usertime));
                new MyBitmapUtils().disPlay(cpfm, good.url);
            }
        } catch (Exception ex) {
            ToastUtils.error("异常信息:" + ex.getMessage());
        }
    }

    /**
     * 将毫秒转化为 分钟：秒 的格式    100* 1000
     *
     * @param millisecond 毫秒
     * @return
     */
    public String formatTime(long millisecond) {
        int minute;//分钟
        int second;//秒数
        minute = (int) ((millisecond / 1) / 60);
        second = (int) ((millisecond / 1) % 60);
        if (minute < 10) {
            if (second < 10) {
                return "0" + minute + "分" + "0" + second + "秒";
            } else {
                return "0" + minute + " : " + second;
            }
        } else {
            if (second < 10) {
                return minute + "分" + "0" + second + "秒";
            } else {
                return minute + "分" + second + "秒";
            }
        }
    }

    /**
     * 设置显示
     *
     * @param index
     */
    public void SetVisibility(int index) {
        try {
            if (index == 1) {
                dialog_xtkz.setVisibility(View.VISIBLE);
                dialog_hlkz.setVisibility(View.GONE);
                dialog_kbkz.setVisibility(View.GONE);
                dialog_jykz.setVisibility(View.GONE);
            } else if (index == 2) {
                dialog_xtkz.setVisibility(View.GONE);
                dialog_hlkz.setVisibility(View.VISIBLE);
                dialog_kbkz.setVisibility(View.GONE);
                dialog_jykz.setVisibility(View.GONE);
            } else if (index == 3) {
                dialog_xtkz.setVisibility(View.GONE);
                dialog_hlkz.setVisibility(View.GONE);
                dialog_kbkz.setVisibility(View.VISIBLE);
                dialog_jykz.setVisibility(View.GONE);
            } else if (index == 4) {
                dialog_xtkz.setVisibility(View.GONE);
                dialog_hlkz.setVisibility(View.GONE);
                dialog_kbkz.setVisibility(View.GONE);
                dialog_jykz.setVisibility(View.VISIBLE);
            } else {
                dialog_xtkz.setVisibility(View.GONE);
                dialog_hlkz.setVisibility(View.GONE);
                dialog_kbkz.setVisibility(View.GONE);
                dialog_jykz.setVisibility(View.GONE);
            }
        } catch (Exception ex) {

        }
    }
    //endregion
}