package com.bonait.bnframework.modules.home.fragment.from;

import androidx.appcompat.app.AppCompatActivity;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.InputType;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.NetworkUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.adapter.wl_adapter;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class JcsjglActivity extends BaseActivity implements MyClickListener {

    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;
    @BindView(R.id.add_wl)
    Button add_wl;
    @BindView(R.id.datatab_wl)
    ListView datatab_wl;

    /**
     * 物料数据
     */
    ArrayList<BPA_MATERIAL> bpa_materials = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_jcsjgl);

        ButterKnife.bind(this);
        initTopBar();
        InitView();
    }


    private void initTopBar() {
        mTopBar.setTitle("基础数据管理");
        mTopBar.addLeftImageButton(R.mipmap.fanhui,R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
    }
    /**
     * 初始化界面
     */
    public void InitView() {
        Initdata_wl();
    }

    @OnClick({R.id.add_wl, R.id.synchronous})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.add_wl://增加物料
                final QMUIDialog.EditTextDialogBuilder builder_add = new QMUIDialog.EditTextDialogBuilder(this);
                builder_add.setTitle("物料名称")
                        .setPlaceholder("在此输入物料名称")
                        .setInputType(InputType.TYPE_CLASS_TEXT)
                        .addAction("取消", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                dialog.dismiss();
                            }
                        })
                        .addAction("确定", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                CharSequence text = builder_add.getEditText().getText();
                                if (text != null && text.length() > 0) {
                                    if (QueryDB.GetMaterialIs(text.toString())) {
                                        ToastUtils.info("物料名称重复,请重新输入后重试!");
                                        return;
                                    }
                                    BPA_MATERIAL bpa_material = new BPA_MATERIAL();
                                    bpa_material.name = text.toString();
                                    bpa_material.imgUrl = "";
                                    bpa_material.type = 0;
                                    bpa_material.deviceID = ConfigName.getInstance().DeviceId;
                                    bpa_material.userID = ConfigName.getInstance().user.userID;
                                    QueryDB.AddMaterial(bpa_material);
                                    ToastUtils.info("新增成功");
                                    Initdata_wl();
                                    dialog.dismiss();
                                } else {
                                    //请填入昵称
                                    ToastUtils.info("物料名称不能为空！");
                                }
                            }
                        })
                        .show();
                break;
            case R.id.synchronous://同步云端
                Context x=this;
                if (NetworkUtils.checkNetworkAvailable(this)) {
                    final QMUIDialog.EditTextDialogBuilder builder = new QMUIDialog.EditTextDialogBuilder(this);
                    builder.setTitle("密码确认")
                            .setPlaceholder("在此输入权限密码")
                            .setInputType(InputType.TYPE_CLASS_TEXT)
                            .addAction("取消", new QMUIDialogAction.ActionListener() {
                                @Override
                                public void onClick(QMUIDialog dialog, int index) {
                                    dialog.dismiss();
                                }
                            })
                            .addAction("确定", new QMUIDialogAction.ActionListener() {
                                @Override
                                public void onClick(QMUIDialog dialog, int index) {
                                    CharSequence text = builder.getEditText().getText();
                                    if (text != null && text.length() > 0) {
                                        if (text.toString().equals(ConfigName.getInstance().user.pass)) {
                                            ConfigData.getInstance().SyncDataInTheCloud(x,mHandler);
                                            dialog.dismiss();
                                        } else {
                                            ToastUtils.info("权限密码不正确！");
                                        }
                                    } else {
                                        ToastUtils.info("权限密码不正确！");
                                    }
                                }
                            })
                            .show();
                } else {
                    ToastUtils.warning("无网络,请先连接网络!!!");
                }
                break;
        }
    }


    @SuppressLint("HandlerLeak")
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            if (msg.obj.toString()== "MSG_REFRESH") {
                Initdata_wl();
            }
        }
    };
    //region 数据加载

    /**
     * 初始化数据加载
     */
    public void Initdata_wl() {
        try {
            bpa_materials = QueryDB.GetMaterialALL();
            wl_adapter adapter = new wl_adapter(this, R.layout.wl_item, bpa_materials, this);
            datatab_wl.setAdapter(adapter);
        } catch (Exception e) {

        }
    }
    //endregion

    /**
     * 点击事件
     *
     * @param v
     * @param data
     */
    @Override
    public void clickListener(View v, Object data) {
        switch (v.getId()) {
            case R.id.name://修改物料名称按钮
            case R.id.button_update://修改物料名称按钮
                final QMUIDialog.EditTextDialogBuilder builder = new QMUIDialog.EditTextDialogBuilder(this);
                builder.setTitle("物料名称")
                        .setPlaceholder("在此输入物料名称")
                        .setDefaultText(((BPA_MATERIAL) data).name)
                        .setInputType(InputType.TYPE_CLASS_TEXT)
                        .addAction("取消", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                dialog.dismiss();
                            }
                        })
                        .addAction("确定", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                CharSequence text = builder.getEditText().getText();
                                if (text != null && text.length() > 0) {
                                    if (QueryDB.GetMaterialIs(text.toString())) {
                                        ToastUtils.info("物料名称重复,请重新输入后重试!");
                                        return;
                                    }
                                    QueryDB.UpdateMaterialName(((BPA_MATERIAL) data).id, text.toString());
                                    Initdata_wl();
                                    ToastUtils.info("修改成功");
                                    dialog.dismiss();
                                } else {
                                    //请填入昵称
                                    ToastUtils.info("物料名称不能为空！");
                                }
                            }
                        })
                        .show();
                break;
            case R.id.button_item://删除按钮
                String title = "温馨提示！";
                String message = "客官确定要删除物料【"+((BPA_MATERIAL) data).name+"】吗？";
                AlertDialogUtils.showDialog(this, title, message, new QMUIDialogAction.ActionListener() {
                    @Override
                    public void onClick(QMUIDialog dialog, int index) {
                        QueryDB.DeleteMaterial((BPA_MATERIAL) data);
                        Initdata_wl();
                        ToastUtils.info("删除成功");
                        dialog.dismiss();
                    }
                });
                break;
        }
    }

    @Override
    public void clickListenerNew(View v, int k, Object data) {

    }
    //-------------------------配置viewPager与fragment关联----------------------------//

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }
}