package com.bonait.bnframework.modules.home.fragment.from;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.RecyclerView;
import androidx.recyclerview.widget.StaggeredGridLayoutManager;

import android.os.Bundle;
import android.view.View;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.db.res.lcMode;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.message.MessageLooper;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.adapter.liaochang_adapter;
import com.qmuiteam.qmui.arch.QMUIFragment;
import com.qmuiteam.qmui.arch.QMUIFragmentPagerAdapter;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;

public class SilosNewActivity extends BaseActivity {
    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;

    @BindView(R.id.recycler_view_lll)
    RecyclerView recycler_view_lll;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_silos_new);
        ButterKnife.bind(this);
        initTopBar();
        InitData();
    }

    private void initTopBar() {
        mTopBar.setTitle("料仓管理");
        mTopBar.addLeftImageButton(R.mipmap.fanhui, R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });


    }

    /**
     * 料仓数据
     */
    ArrayList<lcMode> lcModes =new ArrayList<>();

    ArrayList<BPA_MATERIAL> bpa_materials = new ArrayList<>();

    /**
     * 初始化数据
     */
    public void InitData() {
        lcModes = DataBus.getInstance().ResGetLc();
        bpa_materials = QueryDB.GetMaterialALL();

        StaggeredGridLayoutManager layout11 = new StaggeredGridLayoutManager
                (3, StaggeredGridLayoutManager.VERTICAL);
        recycler_view_lll.setLayoutManager(layout11);

        liaochang_adapter adapter = new liaochang_adapter(this, lcModes,bpa_materials);
        recycler_view_lll.setAdapter(adapter);
        adapter.notifyDataSetChanged();
    }
}