package com.bonait.bnframework.modules.home.fragment.mode;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.os.Bundle;
import android.text.InputFilter;
import android.text.InputType;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.helper.RangeInputFilter;
import com.litao.slider.NiftySlider;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;

public class fragment_gx extends LinearLayout {
    @BindView(R.id.name)
    TextView name;
    @BindView(R.id.editsp_PF)
    Spinner editsp;
    Map<String,Integer> editsp_map = new LinkedHashMap<>();
    @BindView(R.id.edittextPF)
    EditText edittext;
    @BindView(R.id.check_PF)
    CheckBox check;

    @BindView(R.id.nifty_sliderPF)
    NiftySlider nifty_slider;
    private View root;
    public item_gx model;
    public fragment_gx(Context context, @Nullable AttributeSet attrs,item_gx mode) {
        super(context, attrs);
        root=LayoutInflater.from(context).inflate(R.layout.fragment_item_gx, this);
        ButterKnife.bind(this, root);
        model=mode;
        Init();
    }
    public void Init()
    {
        name.setText(model.name);
        if(model.IsWL)
        {
            check.setVisibility(View.VISIBLE);
        }else
        {
            check.setVisibility(View.GONE);
        }
        check.setChecked(false);
        nifty_slider.setOnValueChangeListener(new NiftySlider.OnValueChangeListener() {
            @Override
            public void onValueChange(@NonNull NiftySlider niftySlider, float v, boolean b) {
                nifty_slider.setThumbText((int) v + "");
            }
        });
        switch (model.datatype)
        {
            case 0://数字
                if(model.name.contains("速度") || model.name.contains("功率")  || model.name.contains("温度"))
                {
                    edittext.setVisibility(View.GONE);
                    editsp.setVisibility(View.GONE);
                    nifty_slider.setVisibility(View.VISIBLE);
                    if(model.name.contains("速度") )
                    {
                        nifty_slider.setValueTo(50);
                    }else if(model.name.contains("功率") )
                    {
                        nifty_slider.setValueTo(100);
                    }else if(model.name.contains("温度") )
                    {
                        nifty_slider.setValueTo(400);
                    }
                }else
                {
                    edittext.setVisibility(View.VISIBLE);
                    editsp.setVisibility(View.GONE);
                    nifty_slider.setVisibility(View.GONE);
                    if(model.IsWL)
                    {
                        edittext.setInputType(InputType.TYPE_CLASS_NUMBER | InputType.TYPE_NUMBER_FLAG_DECIMAL);
                    }else
                    {
                        edittext.setInputType(InputType.TYPE_CLASS_NUMBER);
                    }
                    edittext.setText("0".toCharArray(), 0, "0".length());
                    if(model.name.contains("锅内重量"))
                    {
                        edittext.setFilters(new InputFilter[]{new RangeInputFilter(0, 1000)});
                    }
                }

                break;
            case 1://字符串
                editsp.setVisibility(View.GONE);
                nifty_slider.setVisibility(View.GONE);
                edittext.setVisibility(View.VISIBLE);
                edittext.setInputType(InputType.TYPE_CLASS_TEXT);
                break;
            case 2://选项
                editsp.setVisibility(View.VISIBLE);
                nifty_slider.setVisibility(View.GONE);
                edittext.setVisibility(View.GONE);
                if(!model.data.isEmpty() && model.data.contains("、"))
                {
                    String[] res = model.data.split("[、]");
                    int index=1;
                    for (String item: res)
                    {
                        editsp_map.put(item,index);
                        index++;
                    }
                }else
                {
                    editsp_map.put(model.data,1);
                }
                ArrayAdapter<String> adapter2 = new ArrayAdapter<>(getContext(), R.layout.spinner_text_item, new ArrayList<>(editsp_map.keySet()));
                adapter2.setDropDownViewResource(R.layout.spinner_dropdown_item);
                editsp.setAdapter(adapter2);
                break;
        }
    }
    /**
     * 获取选择变量
     * @return
     */
    public String GetValues()
    {
        String ResStu="";
        switch (model.datatype)
        {
            case 0://数字
                if(model.name.contains("速度") || model.name.contains("功率")  || model.name.contains("温度"))
                {
                    ResStu= String.valueOf((int)nifty_slider.getValue());
                }else
                {
                    String text= edittext.getText().toString();
                    if(text.isEmpty())
                    {
                        text="0";
                    }

                    if(model.IsWL)
                    {
                        double val=Double.parseDouble(text);
                        if(check.isChecked())
                        {
                            ResStu=String.format("%.1f", val);
                        }
                    }else
                    {
                        int val=Integer.parseInt(text);
                        ResStu=String.valueOf(val);
                    }
                }

                break;
            case 1://字符串
                if(model.IsWL)
                {
                    if(check.isChecked())
                    {
                        ResStu=edittext.getText().toString();
                    }
                }else
                {
                    ResStu=edittext.getText().toString();
                }
                break;
            case 2://选项
                ResStu=editsp.getSelectedItem().toString();
                break;
        }
        return ResStu;
    }

    /**
     * 设置变量
     * @param value
     */
    public void SetValues(String value)
    {
        switch (model.datatype)
        {
            case 0://数字
            case 1://字符串
                if(model.name.contains("速度") || model.name.contains("功率")  || model.name.contains("温度"))
                {
                    nifty_slider.setValue(Integer.valueOf(value),true);
                    nifty_slider.setThumbText(value);
                }else
                {
                    edittext.setText(value);
                    if(model.IsWL)
                    {
                        check.setChecked(true);
                    }
                }
                break;
            case 2://选项
                Object res= editsp_map.get(value);
                if(res!=null)
                {
                    editsp.setSelection((int)res-1);
                }
                break;
        }
    }
}